Attribute VB_Name = "ImportTxT_v1_3"
Option Explicit

'--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'-------------------------------------------------ImportTxT_v1.3------------------------------------------------------------------------------------------------------
'Author:    Daniel Frauenrath
'Mail:      daniel.frauenrath@gmx.com
'Release:   08.08.2009
'Version:   1.3
'
'*************************************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<Beschreibung / Discription>>>>>>>>>>>>>>>>>>>>
'**************************************************************************************************************************************************************************
'
'DE: Das Makro liesst Koordinaten aus eine *.txt Datei und erstellt anhand dieser Koordinaten Punkte
'    Des weitern werden mit Hilfe dieser Punkte Verbidnungslinien erstellt
'
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'
'EN: The macro reads coordinates from a *. txt file and creates the basis of these coordinate points
'    In addition, with the help of these points the macro creates Point-to-Point lines
'
'*************************************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<Veraenderungen / Change log>>>>>>>>>>>>>>>>>>>>
'**************************************************************************************************************************************************************************
'Autor:                 Datum:          Zeile/Line:        Modul / UserForm:     Anmerkung/Remark:
'--------------------------------------------------------------------------------------------------------------------------
'Daniel Frauenrath      08.05.2009      xx                  aktuelles            Colletion wurden gegen Array getauscht
'Daniel Frauenrath      08.08.2009      xx                  aktuelles            *.txt Format geaendert
'Daniel Frauenrath      30.03.2010      xx                  aktuelles            Andern der Variablenname, Aendern der Dateitypen fuer Kordinaten
'
'
'
'****************************************************************************************************************************************************
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Hauptmakro>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'****************************************************************************************************************************************************

Sub CATMain()

    'Die Statusleiste von CATIA Aendern
    CATIA.StatusBar = "Import *.txt-File wird ausgefuehrt...BITTE WARTEN!"

    
'**********************************Disclaimer**********************************
    'Deklaration der Variablen fuer den Disclaimer
    Dim M1, M11, M12, M2, M3, M4, M5, M51, M6, M7, M8, M9, M10, Titel As String
    Dim Skin As VbMsgBoxStyle
    Dim Disclaimer As VbMsgBoxResult
    
    

    'Werte an Variablen uebergeben (fuer Disclaimer)
    M1 = "==>Diese Makro uebertraegt Punkte von einer *.txt Datei nach CATIA V5<=="
    M11 = "Es muss ein CATPart geladen sein, um das Makro auszufuehren"
    M12 = "Die Formatierung der *.txt-Datei MUSS unbedingt eingehalten werden da es sonst zu Fehlern in der Ausfuehrung des Scriptes kommt!"
    M2 = "Der Autor sprich sich von jeglicher Haftung frei!"
    M3 = "Dieses Makro wurde nur zu Testzwecken fuer cad.de entwickelt. Fuer jegliche andere Art von Nutzung ist ausschliesslich der Anwender haftbar."
    M4 = "Das Makro unterliegt keinen gesetzlichen Richtlinien. Es kann vervielfaelltigt, geaendert und verkauft werden."
    M5 = "<<<<<<<<<<<<Mit dem Klick auf den >>OK<< Button bestaetigt der Anwender die oben genannten Bedingungen>>>>>>>>>>>>"
    M51 = "<<<<<<<<<<<<Mit dem Klick auf den >>ABBRUCH<< Button wird das Makro sofort beendet>>>>>>>>>>>>"
    M6 = "Autor:" + Chr(9) + Chr(9) + "Daniel Frauenrath"
    M7 = "Nickname:" + Chr(9) + "DanielFr."
    M8 = "Email:" + Chr(9) + Chr(9) + "daniel.frauenrath@gmx.com"
    M9 = "Datum:" + Chr(9) + Chr(9) + "08.08.2009"
    Titel = "Disclaimer"
    Skin = vbExclamation + vbOKCancel + vbMsgBoxSetForeground

    'MessageBox anzeigen
    Disclaimer = MsgBox(M1 + Chr(10) + Chr(10) + M11 + Chr(10) + M12 + Chr(10) + Chr(10) + M2 + Chr(10) + M4 + Chr(10) + Chr(10) + _
                        M5 + Chr(10) + M51 + Chr(10) + Chr(10) + M6 + Chr(10) + M7 + Chr(10) + M8 + Chr(10) + M9 + Chr(10) + Chr(10), Skin, Titel)
        'Makro abbrechen falls der Anwender die MessageBox abbricht (Sicherheitsabfrage)
        If Disclaimer = vbCancel Then
            Box = MsgBox("Der Anwender hat sich gegen die Nutzung des Makros entschieden" + Chr(10) + "Das Makro wird nun beendet", vbInformation, "Abbruch durch Anwender")
            Exit Sub
        End If
        
'**********************************Abfrage Dokumente**********************************
    'Deklaration der Variablen
    Dim intWindowsObj As Windows
    Dim intDocObj As Document
    Dim intObjTypeStr As String
    Dim intNoDocMsgBoxRes As VbMsgBoxResult
    
    'Alle geoeffneten Fenster in CATIA holen
    Set intWindowsObj = CATIA.Windows
    'Abfrage ob ueberhaupt ein Fenster offen ist (wenn nicht => kein Dokument geladen => Makro wird abgebrochen)
    If intWindowsObj.Count = 0 Then
        intNoDocMsgBoxRes = MsgBox("Es ist kein Dokument geladen!" + Chr(10) + "Wollen Sie ein neues CATPart Dokument erzeugen?" _
                                    , vbQuestion + vbYesNo, "Neues Dokument erzeugen")
        If intNoDocMsgBoxRes = vbNo Then
            MsgBox "Sie haben die Erstellung des neuen Dokumentes verneint!" + Chr(10) + "Das Makro kann nur mit einem geoeffneten, " & _
                    "aktiven CATPart ausgefuehrt werden" + Chr(10) + "Das Makro wird beendet", vbExclamation, "Abbruch durch Anwender"
            Exit Sub
        Else
            CATIA.Documents.Add ("Part")
        End If
    End If
    'Das aktive Fenster (also aktive Dokument) in eine Variable (oDoc) holen
    Set intDocObj = CATIA.ActiveDocument
    'Den Dateityp des aktiven Dokuments auslesen
    intObjTypeStr = TypeName(intDocObj)
    'Das aktive Dokument MUSS ein Part sein (sonst kann das Script keine Punkte einfügen)
    If intObjTypeStr <> "PartDocument" Then
        MsgBox "Das aktive Dokument ist kein PartDocument!" + Chr(10) + "Das Makro kann nicht ausgefuehrt werden!", _
                vbCritical + vbOKOnly, "Falscher Dokumententyp"
        Exit Sub
    End If
    
    'Variable leeren
    intObjTypeStr = ""
    
'**********************************Aktives Part zuguenglich machen**********************************
    'Deklaration der Variablen zum Einfuegen der Punkte in das Part
    Dim intPartObj As Part
    Dim intHybShapeFacObj As HybridShapeFactory
    Dim intHybBodiesObj As HybridBodies
    
    'Part zuguenglich machen und in Variable speichern
    Set intPartObj = intDocObj.Part
    'Die ShapeFactory (also Flaechen bzw. offene Konturen) Schnittstelle von CATIA ansprechen (diese kann Punkte erstellen)
    Set intHybShapeFacObj = intPartObj.HybridShapeFactory
    'Die geometrischen Set zugaenglich machen (da werden die Punkte ja eingefuegt)
    Set intHybBodiesObj = intPartObj.HybridBodies
   
'**********************************Quelldatei oeffnen und Quellpfad auslesen**********************************
    'Deklaration des Quellpfades (der *.txt Datei)
    Dim intSourcePathStr As String
    
    'Die File-Open Box anzeigen
    intSourcePathStr = CATIA.FileSelectionBox("Quelldatei oeffnen", "*.txt", CatFileSelectionModeOpen)
    
    'Falls die Box abgebrochen wird, dann wird das Makro beendet
    If intSourcePathStr = "" Then
        Box = MsgBox("Abbruch durch Anwender!" + Chr(10) + "Das Makro wird beendet!", vbInformation, "ABBRUCH")
        Exit Sub
    End If
    
'************************************.txt-Datei auslesen**********************************
    'Variablen zum Auslesen der Punkte deklarieren
    Dim intFileObj As File
    Dim intTextStreamObj As TextStream
    Dim intLineStr As String
    Dim intFirstLineStrArr() As String
    Dim intLineCounterInt As Integer
    Dim intmyCheckBool As Boolean
    Dim intLineStrArr() As String
    Dim intLinesArr() As String
    Dim intLineDelimiterStr As String
    Dim intFinLineStr As String
    
    'alle Counter und Checks auf null bzw. auf false setzen
    intLineCounterInt = 0
    intmyCheckBool = False
    
    'Die *.txt-Datei in Variable (oFile) holen
    Set intFileObj = CATIA.FileSystem.GetFile((intSourcePathStr))
    
    'Die *.txt-Datei als TextStream (also als zusammenhuengenden Ascci-String in Variable speichern)
    Set intTextStreamObj = intFileObj.OpenAsTextStream("ForReading")
    
    'Schleife wird solange wiederholt bis die Zeile leer ist (also das Ende der Punkteingabe)
    CATIA.StatusBar = "Lese Punkte aus *.txt Datei..."
    Do
        'Eine Zeile aus dem TextStream lesen
        intLineStr = intTextStreamObj.ReadLine
        
        'Falls diese leer ist soll das Script sofort aus der Schleife springen
        If intLineStr = "" Then
            Exit Do
        End If
        
        'Hier wird die komplette erste Zeile zerlegt (das Zerlegungszeichen ist ein {TAB})
        'Deine Punktkoordinaten sind ja mit TABs getrennt. Daher findet man so die erste "wahre" Zeile (mit Koordinaten)
        intFirstLineStrArr = Split(intLineStr, Chr(9))

        'Wenn noch keine Zeile mit Koordinaten gelesen wurde und der zerlegte String eine 1 ist dann sind in dieser Zeile
        'die ersten Koordinaten die gelesen werden muessen
        If intLineCounterInt = 0 And intFirstLineStrArr(0) = "1" Then
            intmyCheckBool = True
        'Falls schon eine Zeile mit Koordinaten gelesen wurde und der zerlegte String die Summe aus den bereits gelesenen
        'Zeilen und 1 ist ist der Script in der nächsten Zeile mit Koordinaten
        ElseIf intLineCounterInt > 0 And intFirstLineStrArr(0) = CStr(intLineCounterInt + 1) Then
            intmyCheckBool = True
        Else
            intmyCheckBool = False
        End If
        'Falls das Script eine Zeile mit Koordinaten gelesen hat
        If intmyCheckBool = True Then
            'Gelesene Zeilen Counter hochzaehlen
            intLineCounterInt = intLineCounterInt + 1
            'Den String angeben an dem die Zeile zerlegt werden soll (deine Koordinaten sind mit TABs getrennt)
            intLineDelimiterStr = Chr(9)
            'Die aktelle Zeile zerlegen (das Zerlegungszeichen ist ein {TAB})
            intLineStrArr = Split(intLineStr, intLineDelimiterStr)
            'Das Array muss mindestens 3 Einträge haben (X,Y,Z)
            If UBound(intLineStrArr) > 3 Then
                'Falls es min. 3 Eintrage hat wird hier eine Zeile in ein temporoeres Array geschieben
                'Das Format wird im Script bestimmt (X tab Y tab Z). An den TABs wird nachher zerlegt
                'um einzelne Koordinaten fuer die Punkte zu bekommen
                intFinLineStr = intLineStrArr(1) + Chr(9) + intLineStrArr(2) + Chr(9) + intLineStrArr(3)
                'Hier wird das dimensionslose Array dimensioniert
                ReDim Preserve intLinesArr(intLineCounterInt)
                'Hier wird die obige Zeile zum Array hinzugefügt
                intLinesArr(intLineCounterInt) = intFinLineStr
            End If
        End If
    Loop Until intLineStr = ""
    
    
'***myLines-Collection auslesen (das selbsterstellte Array auslesen und verarbeiten)
    'Variablen deklarieren
    Dim intPointCoordDblArr() As Double
    Dim intPointSplitterStrArr() As String
    Dim i As Integer
    Dim intPointCounterInt As Integer
    Dim intXCoordDbl As Double
    Dim intYCoordDbl As Double
    Dim intZCoordDbl As Double
    
    CATIA.StatusBar = "Erstellen Punktkoordinaten..."
    
    'Zaehler auf null setzen
    intPointCounterInt = 0
    
    'Schleife durch alle Eintraege des selbst erstellten Arrays um die Zeilen in einzelne Koordinaten zu zerlegen
    For i = 1 To UBound(intLinesArr)
        'Hier wird aus der ersten Zeile (das wird ducrh das i gesteuert) die erste Zahl (X-Wert n-ter Punkt) ausgelesen und in ein
        'neues Array gespeichert
        intPointCounterInt = intPointCounterInt + 1
        intPointSplitterStrArr = Split(intLinesArr(i), Chr(9))
        
        intXCoordDbl = CDbl(CStr(Replace(intPointSplitterStrArr(0), ".", ",")))
        ReDim Preserve intPointCoordDblArr(intPointCounterInt)
        intPointCoordDblArr(intPointCounterInt) = intXCoordDbl
        
        'Hier wird die zweite Zahl (Y-Wert n-ter Punkt) ausgelesen und in das Array gespeichert
        intPointCounterInt = intPointCounterInt + 1
        intYCoordDbl = CDbl(CStr(Replace(intPointSplitterStrArr(1), ".", ",")))
        ReDim Preserve intPointCoordDblArr(intPointCounterInt)
        intPointCoordDblArr(intPointCounterInt) = intYCoordDbl
        
        'Hier wird die dritte Zahl (Z-Wert n-ter Punkt) ausgelesen und in das Array gespeichert
        intPointCounterInt = intPointCounterInt + 1
        intZCoordDbl = CDbl(CStr(Replace(intPointSplitterStrArr(2), ".", ",")))
        ReDim Preserve intPointCoordDblArr(intPointCounterInt)
        intPointCoordDblArr(intPointCounterInt) = intZCoordDbl
     Next

'************************************Punkte erstellen**********************************
        
    'Deklaration der Variablen
    Dim intGeoSetNameRawStrArr() As String
    Dim intGeoSetName As String
    Dim intGeoSetObj As HybridBody
    Dim intPointNameStr As String
    Dim j As Integer
    Dim intPointObj As Point
             
    'Zaehler auf null setzen
    intPointCounterInt = 0
    
    CATIA.StatusBar = "Erstelle 3D-Punkte..."
    
    'Namen fuer das geometrische Set erstellen
    intGeoSetNameRawStrArr = Split(intFileObj.Name, ".txt")
    intGeoSetName = intGeoSetNameRawStrArr(0)
    
    'geometrisches Set zum Part hinzufuegen
    Set intGeoSetObj = intHybBodiesObj.Add()
    'Namen des geometrischen Sets Aendern
    intGeoSetObj.Name = "Transfer von " & intGeoSetName
    
    'Schleife fuer alle Koordinaten. Aus der letzen Schleife geht ein Array hervor bei dem alle Punktkoordinaten
    'hintereinander stehen. D.h. Item 1-3 sind die X,Y,Z-Koordinaten des ersten Punktes, Item 4-6 sind die X,Y,Z-
    'Koordinaten des zweiten Punktes usw.
    For j = 1 To UBound(intPointCoordDblArr) Step 3
        'Zaehler fuer Punktpreffix erstellen
        intPointCounterInt = intPointCounterInt + 1
        'Punktname erstellen
        intPointNameStr = "__Point." & intPointCounterInt
        'Den Punkt mit den ausgelesenen Koordinaten erstellen
        Set intPointObj = intHybShapeFacObj.AddNewPointCoord(intPointCoordDblArr(j), intPointCoordDblArr(j + 1), intPointCoordDblArr(j + 2))
        'Punkt zum geometrischen Set hinzufuegen
        intGeoSetObj.AppendHybridShape intPointObj
        'den Namen des Punktes Aendern
        intPointObj.Name = intPointNameStr
        'und anschliessend noch das Objekt zur Sicherheit zerstoeren ;-)
        Set intPointObj = Nothing
    Next

    'Das ganze Part updaten
    intPartObj.Update
    CATIA.StatusBar = "Punkte wurden erfolgreich erstellt!"

'************************************Abschluss**********************************
    Dim Ab1, Ab2, Ab3, AbName As String
    Dim AbSkin As VbMsgBoxStyle
    Dim Abschluss As VbMsgBoxResult
    
    Ab1 = "Das Makro wurde erfolgreich beendet"
    Ab2 = "Es wurden " & UBound(intPointCoordDblArr) / 3 & " Punkte erstellt"
    AbSkin = vbOKOnly + vbInformation
    AbName = "Makro erfogreich beendet"
    
    Abschluss = MsgBox(Ab1 + Chr(10) + Chr(10) + Ab2, AbSkin, AbName)
    
    CATIA.StatusBar = ""

End Sub



